<?php 

namespace Drupal\noahs_page_builder;

use Drupal\file\Entity\File;
use Drupal\image\Entity\ImageStyle;

class Control_Noahs_Background_Gradient{
	
	public function get_type() {
		return 'noahs_background_gradient';
	}

	public function content_template($data, $name, $value) {
		// $option = $data['value']['option'];
		$id = $data['wid'];
	
		$gradients_options = [
			'' => 'Select',
			'horizontal' => 'horizontal →',
			'vertical' => 'vertical ↓',
			'diagonal' => 'diagonal ↘',
			'diagonal-bottom' => 'diagonal ↗',
			'radial' => 'radial ○'
		];
	
		$value = !empty($value['gradient']) ? $value['gradient'] : '';
	
		$html = '<div class="field_group field_item mb-3">';
		$html .= '<label for="background_option_type">Background Gradient</label>';
		$html .= '<select class="orientation form-control" name="' . htmlspecialchars($name) . '[gradient][type]" id="background_option_gradient_type" field-settings>';
		foreach ($gradients_options as $k => $label) {
			$selected = (!empty($value['type']) && $value['type'] === $k) ? 'selected' : '';
			$html .= '<option value="' . htmlspecialchars($k) . '" ' . $selected . '>' . htmlspecialchars($label) . '</option>';
		}
		$html .= '</select>';
		$html .= '</div>';
	
		$html .= '<div class="field_group field_item field__color mb-3">';
		$html .= '<label for="background_option_gradient">Color primario</label>';
		$html .= '<input type="text" name="' . htmlspecialchars($name) . '[gradient][start][color]" id="background_option_gradient_start" class="form-control-color-alpha" value="' . htmlspecialchars($value['start']['color'] ?? '') . '" field-settings>';
		$html .= '</div>';
	
		$html .= '<div class="field_group field_item mb-3">';
		$html .= '<label for="background_option_start">Start location</label>';
		$html .= '<input type="number" name="' . htmlspecialchars($name) . '[gradient][start][location]" id="background_option_gradient_start_location" value="' . htmlspecialchars($value['start']['location'] ?? '') . '" class="form-control" field-settings>';
		$html .= '</div>';
	
		$html .= '<div class="field_group field_item field__color mb-3">';
		$html .= '<label for="background_option_gradient">Color secundario</label>';
		$html .= '<input type="text" name="' . htmlspecialchars($name) . '[gradient][end][color]" id="background_option_gradient_end" class="form-control-color-alpha" value="' . htmlspecialchars($value['end']['color'] ?? '') . '" field-settings>';
		$html .= '</div>';
	
		$html .= '<div class="field_group field_item mb-3">';
		$html .= '<label for="background_option_end">End location</label>';
		$html .= '<input type="number" name="' . htmlspecialchars($name) . '[gradient][end][location]" id="background_option_gradient_end_location" class="form-control" value="' . htmlspecialchars($value['end']['location'] ?? '') . '" field-settings>';
		$html .= '</div>';
	
		return $html;
	}
	

	protected function get_default_settings() {
		return [
			'input_type' => 'noahs_background_gradient',
			'placeholder' => '',
			'title' => '',
		];
	}
}