<?php 
namespace Drupal\noahs_page_builder;
use Drupal\noahs_page_builder\Controls_Base;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Drupal\noahs_page_builder\ModalForm;

class Control_Noahs_Coordinates extends Controls_Base {
	private function register_autoloader() {
		require_once NOAHS_PAGE_BUILDER_PATH . '/includes/autoloader.php';
		Autoloader::run();
	  }
	
	  public function __construct() {
		$this->register_autoloader();
	  }
	
	public function get_type() {
		return 'noahs_coordinates';
	}

	public function content_template($data, $name, $value) {
		$fields = $data['item']['fields'];
		$html = '';
	
		$html .= '<div class="nohas-field-description">Use your property as px, em, rem, %, ...</div>';
		$html .= '<ul class="field-element-list-horizontal">';
	
		foreach ($fields as $key => $field) {
			$final_value = htmlspecialchars($value[$key] ?? '', ENT_QUOTES, 'UTF-8');
			$field_title = htmlspecialchars($field['title'] ?? $key, ENT_QUOTES, 'UTF-8');
	
			$html .= '<li>';
			$html .= '<input type="text" name="' . htmlspecialchars($name) . '[' . htmlspecialchars($key) . ']" value="' . $final_value . '" class="form-control" field-settings>';
			$html .= '<label for="noahs_page_builder_coordinate_left">' . $field_title . '</label>';
			$html .= '</li>';
		}
	
		$html .= '</ul>';
	
		return $html;
	}
	

	protected function get_default_settings() {
		return [
			'input_type' => 'noahs_coordinates',
			'title' => '',
		];
	}
}

