<?php 

namespace Drupal\noahs_page_builder;

class Control_Noahs_Group_Checkbox {
	
	public function get_type() {
		return 'noahs_group_checkbox';
	}

	public function content_template($data, $name, $value) {
		$html = '';
	
		foreach ($data['item']['options'] as $key => $option) {
			$checked = !empty($value) && isset($value[str_replace('-', '_', $key)]) && $value[str_replace('-', '_', $key)] === $key ? 'checked' : '';
	
			$html .= '<div class="form-check form-switch">';
			$html .= '<input type="checkbox" id="option-' . $key . '" name="' . $name . '[' . str_replace('-', '_', $key) . ']" value="' . $key . '" class="form-check-input" ' . $checked . ' field-settings />';
			$html .= '<label for="option-' . $key . '" class="form-check-label">' . $option . '</label>';
			$html .= '</div>';
		}
	
		return $html;
	}
	
	protected function get_default_settings() {
		return [
			'input_type' => 'noahs_group_checkbox',
			'placeholder' => '',
			'title' => '',
		];
	}
}