<?php 

namespace Drupal\noahs_page_builder;

use Drupal\file\Entity\File;
use Drupal\image\Entity\ImageStyle;

class Control_Noahs_Icon{
	
	public function get_type() {
		return 'noahs_icon';
	}

	public function content_template($data, $name, $value, $delta) {
		$id = $data['wid'];
	
		$icon = isset($value['class']) ? $value['class'] : '';
		$icon = empty($icon) && !empty($data['item']['default_value']) ? $data['item']['default_value'] : $icon;
	
		$image = empty($value['url']) && !empty($data['item']['default_value']) ? $data['item']['default_value'] : $value['url'];
	
		$output = '<div class="media-preview-actions d-flex justify-content-center align-items-center">';
		$output .= '<div class="mb-3 image-svg ' . (empty($value['icon']['url']) ? 'hidden' : '') . '" id="background_thumbnail_svg_' . $delta . '">';
		$output .= '<img src="' . $image . '" alt="Thumbnail" style="width:50px;"></div>';
		$output .= '<input type="hidden" name="' . $name . '[class]" id="noahs_page_builder_icon_class_' . $delta . '" value="' . $icon . '" class="form-control" field-settings>';
		$output .= '<input type="hidden" name="' . $name . '[fid]" id="noahs_page_builder_icon_fid_' . $delta . '" value="' . (!empty($value['icon']['fid']) ? $value['icon']['fid'] : '') . '" class="form-control" field-settings>';
		$output .= '<input type="hidden" name="' . $name . '[url]" id="noahs_page_builder_icon_url_' . $delta . '" value="' . (!empty($value['icon']['url']) ? $value['icon']['url'] : '') . '" class="form-control" field-settings>';
		$output .= '<span class="icon-empty ' . $icon . '"></span>';
		$output .= '<div class="btn-group position-absolute d-flex justify-content-between w-100">';
		$output .= '<button id="nohas_icon_element_' . $delta . '" data-element-id="nohas_icon_element_' . $delta . '" class="btn btn-primary media-select-icon" data-delta="' . $delta . '" title="' . t('Add/change Icon') . '"><i class="fa-solid fa-circle-plus"></i></button>';
		$output .= '<button id="noahs_page_builder_icon_data_remove' . $delta . '" class="btn btn-danger media-remove-icon" data-delta="' . $delta . '" title="' . t('Remove Icon') . '" data-element-id="nohas_icon_element_' . $delta . '"><i class="fa-solid fa-trash"></i></button>';
		$output .= '</div></div>';
	
		return $output;
	}
	

	protected function get_default_settings() {
		return [
			'input_type' => 'noahs_icon',
			'placeholder' => '',
			'title' => '',
		];
	}
}