<?php 

namespace Drupal\noahs_page_builder;

use Drupal\file\Entity\File;
use Drupal\image\Entity\ImageStyle;
use \Drupal\noahs_page_builder\Controller\NoahsController;

class Control_Noahs_Image{
	
	public function get_type() {
		return 'noahs_image';
	}

	public function content_template($data, $name, $value) {
		$image_styles = NoahsController::getImageStyle();
		$no_image = '/'.NOAHS_PAGE_BUILDER_PATH.'/assets/img/no-image-thumbnail.jpg';
		$image = (!empty($value['thumbnail']) || !empty($data['item']['default_value'])) ? ($value['thumbnail'] ?? $data['item']['default_value']) : $no_image;
	
		$output = '';
	
		$output .= '<div class="mb-3 background-image-field">';
		$output .= '<div class="media-preview-actions d-flex justify-content-center align-items-center mb-3">';
		$output .= '<div class="mb-3"><img class="background-thumbnail-image" src="' . $image . '" alt="Thumbnail"></div>';
		$output .= '<input type="hidden" name="' . $name . '[fid]" id="noahs_page_builder_background_image" value="' . ($value['fid'] ?? '') . '" class="form-control background-fid" field-settings>';
		$output .= '<input type="hidden" name="' . $name . '[thumbnail]" id="noahs_page_builder_background_thumbnail" value="' . ($value['thumbnail'] ?? '') . '" class="form-control background-thumbnail" field-settings>';
		$output .= '<div class="btn-group position-absolute d-flex justify-content-between w-100">';
		$output .= '<button class="btn btn-primary media-upload_image area_tooltip" title="' . t('Add/change Image') . '" data-element-id="noahs_page_builder_background_image"><i class="fa-solid fa-circle-plus"></i></button>';
		$output .= '<button class="btn btn-danger media-removebg_image area_tooltip" title="' . t('Remove Image') . '"><i class="fa-solid fa-trash"></i></button>';
		$output .= '</div>';
		$output .= '</div>';
		$output .= '<div class="mb-3">';
		$output .= '<label for="">' . t('Use Media Token Field') . '</label>';
		$output .= '<input type="text" name="' . $name . '[token_media]" value="' . ($value['token_media'] ?? '') . '" class="form-control" field-settings>';
		$output .= '</div>';
		$output .= '<div class="nohas-field-description mb-4">' . t('This is not available on token module, copy and replace your entity, field and style: [node:field_featured_image:entity:field_media_image:og_image_1200x630]') . '</div>';
		$output .= '<div class="field_group field_item mb-3">';
		$output .= '<label for="noahs_page_builder_background_image_style">' . t('Image Style') . '</label>';
		$output .= '<select name="' . $name . '[image_style]" class="form-control noahs-regenerate-design" field-settings>';
		foreach ($image_styles as $k => $style) {
			$selected = (!empty($value['image_style']) && $value['image_style'] === $k) ? 'selected' : '';
			$output .= '<option value="' . $k . '" ' . $selected . '>' . $style . '</option>';
		}
		$output .= '</select>';
		$output .= '</div>';
		$output .= '</div>';
	
		return $output;
	}
	

	protected function get_default_settings() {
		return [
			'input_type' => 'noahs_background',
			'placeholder' => '',
			'title' => '',
		];
	}
}