<?php 

namespace Drupal\noahs_page_builder;


class Control_Noahs_Radius {
	
	public function get_type() {
		return 'noahs_radius';
	}

	public function content_template($data, $name, $value) {
		$output = '';
	
		$output .= '<ul class="field-element-list-horizontal mb-3">';
		$output .= '<li>';
		$output .= '<input type="text" name="' . htmlspecialchars($name, ENT_QUOTES, 'UTF-8') . '[border_top_left_radius]" value="' . (!empty($value['border_top_left_radius']) ? htmlspecialchars($value['border_top_left_radius'], ENT_QUOTES, 'UTF-8') : '') . '" class="form-control" field-settings>';
		$output .= '<label for="noahs_page_builder_border-top-left-radius">Top</label>';
		$output .= '</li>';
		$output .= '<li>';
		$output .= '<input type="text" name="' . htmlspecialchars($name, ENT_QUOTES, 'UTF-8') . '[border_top_right_radius]" value="' . (!empty($value['border_top_right_radius']) ? htmlspecialchars($value['border_top_right_radius'], ENT_QUOTES, 'UTF-8') : '') . '" class="form-control" field-settings>';
		$output .= '<label for="noahs_page_builder_border_top_right_radius">Right</label>';
		$output .= '</li>';
		$output .= '<li>';
		$output .= '<input type="text" name="' . htmlspecialchars($name, ENT_QUOTES, 'UTF-8') . '[border_bottom_right_radius]" value="' . (!empty($value['border_bottom_right_radius']) ? htmlspecialchars($value['border_bottom_right_radius'], ENT_QUOTES, 'UTF-8') : '') . '" class="form-control" field-settings>';
		$output .= '<label for="noahs_page_builder_shadow_border_bottom_right_radius">Bottom</label>';
		$output .= '</li>';
		$output .= '<li>';
		$output .= '<input type="text" name="' . htmlspecialchars($name, ENT_QUOTES, 'UTF-8') . '[border_bottom_left_radius]" value="' . (!empty($value['border_bottom_left_radius']) ? htmlspecialchars($value['border_bottom_left_radius'], ENT_QUOTES, 'UTF-8') : '') . '" class="form-control" field-settings>';
		$output .= '<label for="noahs_page_builder_shadow_border_bottom_left_radius">Left</label>';
		$output .= '</li>';
		$output .= '</ul>';
	
		return $output;
	}
	

	protected function get_default_settings() {
		return [
			'input_type' => 'noahs_radius',
			'placeholder' => '',
			'title' => '',
		];
	}
}