<?php 

namespace Drupal\noahs_page_builder;


class Control_Noahs_Shadows {
	
	public function get_type() {
		return 'noahs_shadows';
	}

	public function content_template($data, $name, $value) {
		$output = '';
	
		$output .= '<ul class="field-element-list-horizontal mb-3">';
		$output .= '<li>';
		$output .= '<input type="text" name="' . htmlspecialchars($name, ENT_QUOTES, 'UTF-8') . '[shadow_x]" value="' . (!empty($value['shadow_x']) ? htmlspecialchars($value['shadow_x'], ENT_QUOTES, 'UTF-8') : '') . '" class="form-control" field-settings>';
		$output .= '<label for="noahs_page_builder_shadow_x">Horizontal</label>';
		$output .= '</li>';
		$output .= '<li>';
		$output .= '<input type="text" name="' . htmlspecialchars($name, ENT_QUOTES, 'UTF-8') . '[shadow_y]" value="' . (!empty($value['shadow_y']) ? htmlspecialchars($value['shadow_y'], ENT_QUOTES, 'UTF-8') : '') . '" class="form-control" field-settings>';
		$output .= '<label for="noahs_page_builder_shadow_y">Vertical</label>';
		$output .= '</li>';
		$output .= '<li>';
		$output .= '<input type="text" name="' . htmlspecialchars($name, ENT_QUOTES, 'UTF-8') . '[blur]" value="' . (!empty($value['blur']) ? htmlspecialchars($value['blur'], ENT_QUOTES, 'UTF-8') : '') . '" class="form-control" field-settings>';
		$output .= '<label for="noahs_page_builder_shadow_blur">Blur</label>';
		$output .= '</li>';
		$output .= '<li>';
		$output .= '<input type="text" name="' . htmlspecialchars($name, ENT_QUOTES, 'UTF-8') . '[spread]" value="' . (!empty($value['spread']) ? htmlspecialchars($value['spread'], ENT_QUOTES, 'UTF-8') : '') . '" class="form-control" field-settings>';
		$output .= '<label for="noahs_page_builder_shadow_spread">Spread</label>';
		$output .= '</li>';
		$output .= '</ul>';
		$output .= '<div class="field__color mb-3">';
		$output .= '<label for="noahs_page_builder_shadow_color" class="form-label">Color</label>';
		$output .= '<input type="text" name="' . htmlspecialchars($name, ENT_QUOTES, 'UTF-8') . '[color]" class="form-control-color-alpha" value="' . (!empty($value['color']) ? htmlspecialchars($value['color'], ENT_QUOTES, 'UTF-8') : '') . '" field-settings>';
		$output .= '</div>';
	
		return $output;
	}
	

	protected function get_default_settings() {
		return [
			'input_type' => 'noahs_shadows',
			'placeholder' => '',
			'title' => '',
		];
	}
}