<?php 

namespace Drupal\noahs_page_builder;

use Drupal\file\Entity\File;
use Drupal\image\Entity\ImageStyle;


class Control_Noahs_Video_Background {
	
	public function get_type() {
		return 'noahs_background';
	}

	public function content_template($data, $name, $value) {
		// $option = $data['value']['option'];
		$id = $data['wid'];
	
		$output = '';
	
		$output .= '<div class="field_element">';
		$output .= '<label for="background_option_video">Background Video URL</label>';
		$output .= '<input type="text" name="' . htmlspecialchars($name, ENT_QUOTES, 'UTF-8') . '[url]" id="background_option_video" value="' . (!empty($value['url']) ? htmlspecialchars($value['url'], ENT_QUOTES, 'UTF-8') : '') . '" class="form-control" field-settings>';
		$output .= '</div>';
	
		$output .= '<div class="field_element field__color">';
		$output .= '<label for="noahs_page_builder_background_overlay">Video Overlay</label>';
		$output .= '<input type="text" name="' . htmlspecialchars($name, ENT_QUOTES, 'UTF-8') . '[video_background_overlay]" id="noahs_page_builder_video_background_overlay" class="form-control-color-alpha" value="' . (!empty($value['video_background_overlay']) ? htmlspecialchars($value['video_background_overlay'], ENT_QUOTES, 'UTF-8') : '') . '" field-settings>';
		$output .= '</div>';
	
		return $output;
	}
	

	protected function get_default_settings() {
		return [
			'input_type' => 'noahs_background',
			'placeholder' => '',
			'title' => '',
		];
	}
}