<?php 

namespace Drupal\noahs_page_builder;



class Control_Noahs_Width{
	
	public function get_type() {
		return 'noahs_width';
	}


	public function content_template($data, $name, $value) {
		$id = $data['wid'];
		$placeholder = !empty($data['item']['placeholder']) ? $data['item']['placeholder'] : '';
	
		$output = '';
	
		$output .= '<div class="field_item form-floating">';
		$output .= '<input type="text" name="' . htmlspecialchars($name, ENT_QUOTES, 'UTF-8') . '" class="form-control" value="' . htmlspecialchars($value, ENT_QUOTES, 'UTF-8') . '" placeholder="' . htmlspecialchars($placeholder, ENT_QUOTES, 'UTF-8') . '" data-element-settings="' . htmlspecialchars($data['item_id'], ENT_QUOTES, 'UTF-8') . '" field-settings>';
		$output .= '<label>' . htmlspecialchars($placeholder, ENT_QUOTES, 'UTF-8') . '</label>';
		$output .= '</div>';
	
		return $output;
	}
	

	protected function get_default_settings() {
		return [
			'input_type' => 'noahs_width',
			'placeholder' => '',
			'title' => '',
		];
	}
}