<?php 
namespace Drupal\noahs_page_builder;
use Drupal\noahs_page_builder\Controls_Base;


class Control_Radio extends Controls_Base {

	public function get_type() {
		return 'radio';
	}

	public function content_template($data, $name, $value) {
		$output = '';
	
		$output .= '<div class="form-check form-switch">';
		$output .= '<input type="radio" id="option-' . htmlspecialchars($data['item_id'], ENT_QUOTES, 'UTF-8') . '" name="element[' . htmlspecialchars($data['item_id'], ENT_QUOTES, 'UTF-8') . ']" value="" class="form-check-input" field-settings>';
		$output .= '<label for="option-' . htmlspecialchars($data['item_id'], ENT_QUOTES, 'UTF-8') . '" class="form-check-label">' . htmlspecialchars($data['item']['title'], ENT_QUOTES, 'UTF-8') . '</label>';
		$output .= '</div>';
	
		return $output;
	}
	
	public function render_control($data){
		return $this->base($data, $this->content_template($data));
	}
	protected function get_default_settings() {
		return [
			'input_type' => 'radio',
			'title' => '',
		];
	}
}

