<?php 


use Drupal\noahs_page_builder\WidgetBase;
use Drupal\block\Entity\Block;

   class element_noahs_drupal_block extends WidgetBase{

      public function data(){
         return [
            'icon' => '<i class="fa-brands fa-drupal"></i>',
            'title' => 'Drupal Block',
            'description' => 'Description',
            'group' => 'Drupal'
         ];
      }
      
      public function render_form(){
         $form = [];
         $options = noahs_page_builder_load_blocks();

         $form['drupal_block'] = [
            'type'    => 'select',
            'title'   => t('Drupal Block'),
            'tab' => 'section_content',
            'options' => $options,
         ];
         return $form;
      }

      public function template( $settings ){


         $settings = $settings->element;

         if(!empty($settings->drupal_block)){

            $block_manager = \Drupal::service('plugin.manager.block');
            $config = [];
            $plugin_block = $block_manager->createInstance($settings->drupal_block, $config);
        
            $access_result = $plugin_block->access(\Drupal::currentUser());
            // Return empty render array if user doesn't have access.
            // $access_result can be boolean or an AccessResult class
            if (is_object($access_result) && $access_result->isForbidden() || is_bool($access_result) && !$access_result) {
            // You might need to add some cache tags/contexts.
            return;
            }

            $render_block = '<div>Missing view, block "'.$settings->drupal_block.'"</div>';
            if($plugin_block){
               $build = $plugin_block->build();

               $render_block = \Drupal::service('renderer')->render(
                  $build
               );
   
           
            }
         }else{
            $render_block = '<div>Select your block before :)</div>';
         }
        
         $output = '<div class="widget-content">';
         $output .= $render_block ?: '<div class="drupal-viewblock-empty">Drupal View</div>';
         $output .= '</div>';
     
         return $output;    
      }
      public function render_content($element) {
         return $this->wrapper($element, $this->template($element->settings));
      }
   }

   



