<?php 


use Drupal\noahs_page_builder\WidgetBase;
use Drupal\Core\Url;

   class element_noahs_drupal_site_logo extends WidgetBase{

      public function data(){
         return [
            'icon' => '<i class="fa-brands fa-drupal"></i>',
            'title' => 'Drupal Site Logo',
            'description' => 'Description',
            'group' => 'Drupal'
         ];
      }
      
      public function render_form(){
         $form = [];

         $form['section_content'] = [
            'type' => 'tab',
            'title' =>  t('Content')
         ];

         $form['logo_width'] =[
            'type'    => 'noahs_width',
            'title'   => ('Logo Width'),
            'style_type' => 'style',
            'style_selector' => '.widget-content img', 
            'style_css' => 'max-width', 
            'tab' => 'section_content',
            'responsive' => true,
            'placeholder' => 'use as 10%, 100px, 100vw...',
         ];

         $form['logo_fixed_width'] =[
            'type'    => 'noahs_width',
            'title'   => ('Logo width on header sticky'),
            'style_type' => 'style',
            'style_selector' => '.noahs-pro-theme--header.sticky [widget] .site__logo', 
            'style_css' => 'max-width', 
            'tab' => 'section_content',
            'responsive' => true,
            'placeholder' => 'use as 10%, 100px, 100vw...',
         ];

         return $form;
      }

      public function template( $settings ){

 
         $logo_relative_path = theme_get_setting('logo.url');
         $element_content = $this->twig()->render(NOAHS_PAGE_BUILDER_PATH . '/templates/widgets/element_noahs_drupal_site_logo.twig', [
            'logo_relative_path' => $logo_relative_path,
         ]);

         return $element_content;

      }

      public function render_content($element) {
         return $this->wrapper($element, $this->template($element->settings));
      }
   }

   



