<?php
/**
 * @file
 * Contains \Drupal\noahs_page_builder\Controller\NoahsPageController.
 */

namespace Drupal\noahs_page_builder\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Drupal\node\Entity\NodeType;
use \Drupal\Component\Render\FormattableMarkup;
use Drupal\Core\Url;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\RequestOptions;
use Symfony\Component\DependencyInjection\ContainerInterface;



class NoahsPageController extends ControllerBase{

  protected $httpClient;

  public function __construct(ClientInterface $httpClient){
    $this->httpClient = $httpClient;
  }

  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('http_client')
    );
  }

    static function view() {
      $url = 'https://noahs-creator.com/banner-json';

      // Realizar la solicitud HTTP para obtener el JSON
      try {
        $options = [];
        $client = \Drupal::httpClient();
        $response = $client->request('GET', $url);
        $data = json_decode($response->getBody()->getContents(), true);
      } catch (\Exception $e) {
        \Drupal\Component\Utility\DeprecationHelper::backwardsCompatibleCall(\Drupal::VERSION, '10.1.0', fn() => \Drupal\Core\Utility\Error::logException(\Drupal::logger('custom_module'), $e), fn() => watchdog_exception('custom_module', $e));
        return [
          '#type' => 'markup',
          '#markup' => t('Unable to fetch banners at this time.'),
        ];
      }
  
      // Array para almacenar los elementos renderizados
      $rendered_banners = [];
  
      foreach ($data as $banner) {

        $rendered_banners[] = [
          '#type' => 'markup',
          '#markup' => '<a href="' . $banner['field_link'] . '" target="_blank"><img src="' . $banner['field_image'] . '"/></a>',
          '#wrapper_attributes' => [
            'class' => ['swiper-slide'],
          ],
        ];
      }
  
      return [
        '#theme' => 'item_list',
        '#items' => $rendered_banners,
        '#attributes' => ['class' => 'swiper-wrapper', ],
        '#wrapper_attributes' => [
          'class' => ['noahs-banner-list swiper-container'],
          'id' => 'noahs_banners_slide'
        ],
        '#attached' => [
          'library' => [
            'noahs_page_builder/noahs_page_builder.banners',
          ],
        ],
      ];
    }


    


}

